// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Directional protection indication information (ACD)
 * </pre>
 *
 * Protobuf type {@code commonmodule.ACD}
 */
public final class ACD extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.ACD)
    ACDOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ACD.newBuilder() to construct.
  private ACD(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ACD() {
    dirGeneral_ = 0;
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ACD();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACD_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACD_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.ACD.class, openfmb.commonmodule.ACD.Builder.class);
  }

  public static final int DIRGENERAL_FIELD_NUMBER = 1;
  private int dirGeneral_ = 0;
  /**
   * <pre>
   * General direction of the fault. If the faults of individual phases have different directions,
   * this attribute shall be set to 'dirGeneral'='both'.
   * </pre>
   *
   * <code>.commonmodule.FaultDirectionKind dirGeneral = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The enum numeric value on the wire for dirGeneral.
   */
  @java.lang.Override public int getDirGeneralValue() {
    return dirGeneral_;
  }
  /**
   * <pre>
   * General direction of the fault. If the faults of individual phases have different directions,
   * this attribute shall be set to 'dirGeneral'='both'.
   * </pre>
   *
   * <code>.commonmodule.FaultDirectionKind dirGeneral = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The dirGeneral.
   */
  @java.lang.Override public openfmb.commonmodule.FaultDirectionKind getDirGeneral() {
    openfmb.commonmodule.FaultDirectionKind result = openfmb.commonmodule.FaultDirectionKind.forNumber(dirGeneral_);
    return result == null ? openfmb.commonmodule.FaultDirectionKind.UNRECOGNIZED : result;
  }

  public static final int DIRNEUT_FIELD_NUMBER = 2;
  private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirNeut_;
  /**
   * <pre>
   * Direction of the fault for earth current.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
   * @return Whether the dirNeut field is set.
   */
  @java.lang.Override
  public boolean hasDirNeut() {
    return dirNeut_ != null;
  }
  /**
   * <pre>
   * Direction of the fault for earth current.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
   * @return The dirNeut.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirNeut() {
    return dirNeut_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirNeut_;
  }
  /**
   * <pre>
   * Direction of the fault for earth current.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirNeutOrBuilder() {
    return dirNeut_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirNeut_;
  }

  public static final int DIRPHSA_FIELD_NUMBER = 3;
  private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA_;
  /**
   * <pre>
   * Direction of the fault for phase A.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
   * @return Whether the dirPhsA field is set.
   */
  @java.lang.Override
  public boolean hasDirPhsA() {
    return dirPhsA_ != null;
  }
  /**
   * <pre>
   * Direction of the fault for phase A.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
   * @return The dirPhsA.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirPhsA() {
    return dirPhsA_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsA_;
  }
  /**
   * <pre>
   * Direction of the fault for phase A.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirPhsAOrBuilder() {
    return dirPhsA_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsA_;
  }

  public static final int DIRPHSB_FIELD_NUMBER = 4;
  private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB_;
  /**
   * <pre>
   * Direction of the fault for phase B.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
   * @return Whether the dirPhsB field is set.
   */
  @java.lang.Override
  public boolean hasDirPhsB() {
    return dirPhsB_ != null;
  }
  /**
   * <pre>
   * Direction of the fault for phase B.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
   * @return The dirPhsB.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirPhsB() {
    return dirPhsB_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsB_;
  }
  /**
   * <pre>
   * Direction of the fault for phase B.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirPhsBOrBuilder() {
    return dirPhsB_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsB_;
  }

  public static final int DIRPHSC_FIELD_NUMBER = 5;
  private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC_;
  /**
   * <pre>
   * Direction of the fault for phase C.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
   * @return Whether the dirPhsC field is set.
   */
  @java.lang.Override
  public boolean hasDirPhsC() {
    return dirPhsC_ != null;
  }
  /**
   * <pre>
   * Direction of the fault for phase C.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
   * @return The dirPhsC.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirPhsC() {
    return dirPhsC_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsC_;
  }
  /**
   * <pre>
   * Direction of the fault for phase C.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirPhsCOrBuilder() {
    return dirPhsC_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsC_;
  }

  public static final int GENERAL_FIELD_NUMBER = 6;
  private boolean general_ = false;
  /**
   * <pre>
   * General indication of a protection activation (e.g. by the fault). Depending on the function,
   * 'general' may or may not be resulting from the phase attributes (phsA', 'phsB', 'phsC', 'neut').
   * </pre>
   *
   * <code>bool general = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The general.
   */
  @java.lang.Override
  public boolean getGeneral() {
    return general_;
  }

  public static final int NEUT_FIELD_NUMBER = 7;
  private com.google.protobuf.BoolValue neut_;
  /**
   * <pre>
   * See 'ACT.neut'.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue neut = 7;</code>
   * @return Whether the neut field is set.
   */
  @java.lang.Override
  public boolean hasNeut() {
    return neut_ != null;
  }
  /**
   * <pre>
   * See 'ACT.neut'.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue neut = 7;</code>
   * @return The neut.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getNeut() {
    return neut_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : neut_;
  }
  /**
   * <pre>
   * See 'ACT.neut'.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue neut = 7;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getNeutOrBuilder() {
    return neut_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : neut_;
  }

  public static final int PHSA_FIELD_NUMBER = 8;
  private com.google.protobuf.BoolValue phsA_;
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase A.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsA = 8;</code>
   * @return Whether the phsA field is set.
   */
  @java.lang.Override
  public boolean hasPhsA() {
    return phsA_ != null;
  }
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase A.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsA = 8;</code>
   * @return The phsA.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getPhsA() {
    return phsA_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsA_;
  }
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase A.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsA = 8;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getPhsAOrBuilder() {
    return phsA_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsA_;
  }

  public static final int PHSB_FIELD_NUMBER = 9;
  private com.google.protobuf.BoolValue phsB_;
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase B.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsB = 9;</code>
   * @return Whether the phsB field is set.
   */
  @java.lang.Override
  public boolean hasPhsB() {
    return phsB_ != null;
  }
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase B.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsB = 9;</code>
   * @return The phsB.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getPhsB() {
    return phsB_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsB_;
  }
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase B.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsB = 9;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getPhsBOrBuilder() {
    return phsB_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsB_;
  }

  public static final int PHSC_FIELD_NUMBER = 10;
  private com.google.protobuf.BoolValue phsC_;
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase C.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsC = 10;</code>
   * @return Whether the phsC field is set.
   */
  @java.lang.Override
  public boolean hasPhsC() {
    return phsC_ != null;
  }
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase C.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsC = 10;</code>
   * @return The phsC.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getPhsC() {
    return phsC_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsC_;
  }
  /**
   * <pre>
   * Value true indicates a trip or a start event of phase C.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue phsC = 10;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getPhsCOrBuilder() {
    return phsC_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsC_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (dirGeneral_ != openfmb.commonmodule.FaultDirectionKind.FaultDirectionKind_UNDEFINED.getNumber()) {
      output.writeEnum(1, dirGeneral_);
    }
    if (dirNeut_ != null) {
      output.writeMessage(2, getDirNeut());
    }
    if (dirPhsA_ != null) {
      output.writeMessage(3, getDirPhsA());
    }
    if (dirPhsB_ != null) {
      output.writeMessage(4, getDirPhsB());
    }
    if (dirPhsC_ != null) {
      output.writeMessage(5, getDirPhsC());
    }
    if (general_ != false) {
      output.writeBool(6, general_);
    }
    if (neut_ != null) {
      output.writeMessage(7, getNeut());
    }
    if (phsA_ != null) {
      output.writeMessage(8, getPhsA());
    }
    if (phsB_ != null) {
      output.writeMessage(9, getPhsB());
    }
    if (phsC_ != null) {
      output.writeMessage(10, getPhsC());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (dirGeneral_ != openfmb.commonmodule.FaultDirectionKind.FaultDirectionKind_UNDEFINED.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(1, dirGeneral_);
    }
    if (dirNeut_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getDirNeut());
    }
    if (dirPhsA_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getDirPhsA());
    }
    if (dirPhsB_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getDirPhsB());
    }
    if (dirPhsC_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getDirPhsC());
    }
    if (general_ != false) {
      size += com.google.protobuf.CodedOutputStream
        .computeBoolSize(6, general_);
    }
    if (neut_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getNeut());
    }
    if (phsA_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getPhsA());
    }
    if (phsB_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(9, getPhsB());
    }
    if (phsC_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(10, getPhsC());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.ACD)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.ACD other = (openfmb.commonmodule.ACD) obj;

    if (dirGeneral_ != other.dirGeneral_) return false;
    if (hasDirNeut() != other.hasDirNeut()) return false;
    if (hasDirNeut()) {
      if (!getDirNeut()
          .equals(other.getDirNeut())) return false;
    }
    if (hasDirPhsA() != other.hasDirPhsA()) return false;
    if (hasDirPhsA()) {
      if (!getDirPhsA()
          .equals(other.getDirPhsA())) return false;
    }
    if (hasDirPhsB() != other.hasDirPhsB()) return false;
    if (hasDirPhsB()) {
      if (!getDirPhsB()
          .equals(other.getDirPhsB())) return false;
    }
    if (hasDirPhsC() != other.hasDirPhsC()) return false;
    if (hasDirPhsC()) {
      if (!getDirPhsC()
          .equals(other.getDirPhsC())) return false;
    }
    if (getGeneral()
        != other.getGeneral()) return false;
    if (hasNeut() != other.hasNeut()) return false;
    if (hasNeut()) {
      if (!getNeut()
          .equals(other.getNeut())) return false;
    }
    if (hasPhsA() != other.hasPhsA()) return false;
    if (hasPhsA()) {
      if (!getPhsA()
          .equals(other.getPhsA())) return false;
    }
    if (hasPhsB() != other.hasPhsB()) return false;
    if (hasPhsB()) {
      if (!getPhsB()
          .equals(other.getPhsB())) return false;
    }
    if (hasPhsC() != other.hasPhsC()) return false;
    if (hasPhsC()) {
      if (!getPhsC()
          .equals(other.getPhsC())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + DIRGENERAL_FIELD_NUMBER;
    hash = (53 * hash) + dirGeneral_;
    if (hasDirNeut()) {
      hash = (37 * hash) + DIRNEUT_FIELD_NUMBER;
      hash = (53 * hash) + getDirNeut().hashCode();
    }
    if (hasDirPhsA()) {
      hash = (37 * hash) + DIRPHSA_FIELD_NUMBER;
      hash = (53 * hash) + getDirPhsA().hashCode();
    }
    if (hasDirPhsB()) {
      hash = (37 * hash) + DIRPHSB_FIELD_NUMBER;
      hash = (53 * hash) + getDirPhsB().hashCode();
    }
    if (hasDirPhsC()) {
      hash = (37 * hash) + DIRPHSC_FIELD_NUMBER;
      hash = (53 * hash) + getDirPhsC().hashCode();
    }
    hash = (37 * hash) + GENERAL_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(
        getGeneral());
    if (hasNeut()) {
      hash = (37 * hash) + NEUT_FIELD_NUMBER;
      hash = (53 * hash) + getNeut().hashCode();
    }
    if (hasPhsA()) {
      hash = (37 * hash) + PHSA_FIELD_NUMBER;
      hash = (53 * hash) + getPhsA().hashCode();
    }
    if (hasPhsB()) {
      hash = (37 * hash) + PHSB_FIELD_NUMBER;
      hash = (53 * hash) + getPhsB().hashCode();
    }
    if (hasPhsC()) {
      hash = (37 * hash) + PHSC_FIELD_NUMBER;
      hash = (53 * hash) + getPhsC().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.ACD parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ACD parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ACD parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ACD parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ACD parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ACD parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ACD parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ACD parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ACD parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ACD parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ACD parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ACD parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.ACD prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Directional protection indication information (ACD)
   * </pre>
   *
   * Protobuf type {@code commonmodule.ACD}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.ACD)
      openfmb.commonmodule.ACDOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACD_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACD_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.ACD.class, openfmb.commonmodule.ACD.Builder.class);
    }

    // Construct using openfmb.commonmodule.ACD.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      dirGeneral_ = 0;
      dirNeut_ = null;
      if (dirNeutBuilder_ != null) {
        dirNeutBuilder_.dispose();
        dirNeutBuilder_ = null;
      }
      dirPhsA_ = null;
      if (dirPhsABuilder_ != null) {
        dirPhsABuilder_.dispose();
        dirPhsABuilder_ = null;
      }
      dirPhsB_ = null;
      if (dirPhsBBuilder_ != null) {
        dirPhsBBuilder_.dispose();
        dirPhsBBuilder_ = null;
      }
      dirPhsC_ = null;
      if (dirPhsCBuilder_ != null) {
        dirPhsCBuilder_.dispose();
        dirPhsCBuilder_ = null;
      }
      general_ = false;
      neut_ = null;
      if (neutBuilder_ != null) {
        neutBuilder_.dispose();
        neutBuilder_ = null;
      }
      phsA_ = null;
      if (phsABuilder_ != null) {
        phsABuilder_.dispose();
        phsABuilder_ = null;
      }
      phsB_ = null;
      if (phsBBuilder_ != null) {
        phsBBuilder_.dispose();
        phsBBuilder_ = null;
      }
      phsC_ = null;
      if (phsCBuilder_ != null) {
        phsCBuilder_.dispose();
        phsCBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACD_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.ACD getDefaultInstanceForType() {
      return openfmb.commonmodule.ACD.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.ACD build() {
      openfmb.commonmodule.ACD result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.ACD buildPartial() {
      openfmb.commonmodule.ACD result = new openfmb.commonmodule.ACD(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.ACD result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.dirGeneral_ = dirGeneral_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.dirNeut_ = dirNeutBuilder_ == null
            ? dirNeut_
            : dirNeutBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.dirPhsA_ = dirPhsABuilder_ == null
            ? dirPhsA_
            : dirPhsABuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.dirPhsB_ = dirPhsBBuilder_ == null
            ? dirPhsB_
            : dirPhsBBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.dirPhsC_ = dirPhsCBuilder_ == null
            ? dirPhsC_
            : dirPhsCBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.general_ = general_;
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.neut_ = neutBuilder_ == null
            ? neut_
            : neutBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000080) != 0)) {
        result.phsA_ = phsABuilder_ == null
            ? phsA_
            : phsABuilder_.build();
      }
      if (((from_bitField0_ & 0x00000100) != 0)) {
        result.phsB_ = phsBBuilder_ == null
            ? phsB_
            : phsBBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000200) != 0)) {
        result.phsC_ = phsCBuilder_ == null
            ? phsC_
            : phsCBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.ACD) {
        return mergeFrom((openfmb.commonmodule.ACD)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.ACD other) {
      if (other == openfmb.commonmodule.ACD.getDefaultInstance()) return this;
      if (other.dirGeneral_ != 0) {
        setDirGeneralValue(other.getDirGeneralValue());
      }
      if (other.hasDirNeut()) {
        mergeDirNeut(other.getDirNeut());
      }
      if (other.hasDirPhsA()) {
        mergeDirPhsA(other.getDirPhsA());
      }
      if (other.hasDirPhsB()) {
        mergeDirPhsB(other.getDirPhsB());
      }
      if (other.hasDirPhsC()) {
        mergeDirPhsC(other.getDirPhsC());
      }
      if (other.getGeneral() != false) {
        setGeneral(other.getGeneral());
      }
      if (other.hasNeut()) {
        mergeNeut(other.getNeut());
      }
      if (other.hasPhsA()) {
        mergePhsA(other.getPhsA());
      }
      if (other.hasPhsB()) {
        mergePhsB(other.getPhsB());
      }
      if (other.hasPhsC()) {
        mergePhsC(other.getPhsC());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              dirGeneral_ = input.readEnum();
              bitField0_ |= 0x00000001;
              break;
            } // case 8
            case 18: {
              input.readMessage(
                  getDirNeutFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getDirPhsAFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getDirPhsBFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getDirPhsCFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 48: {
              general_ = input.readBool();
              bitField0_ |= 0x00000020;
              break;
            } // case 48
            case 58: {
              input.readMessage(
                  getNeutFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000040;
              break;
            } // case 58
            case 66: {
              input.readMessage(
                  getPhsAFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000080;
              break;
            } // case 66
            case 74: {
              input.readMessage(
                  getPhsBFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000100;
              break;
            } // case 74
            case 82: {
              input.readMessage(
                  getPhsCFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000200;
              break;
            } // case 82
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private int dirGeneral_ = 0;
    /**
     * <pre>
     * General direction of the fault. If the faults of individual phases have different directions,
     * this attribute shall be set to 'dirGeneral'='both'.
     * </pre>
     *
     * <code>.commonmodule.FaultDirectionKind dirGeneral = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The enum numeric value on the wire for dirGeneral.
     */
    @java.lang.Override public int getDirGeneralValue() {
      return dirGeneral_;
    }
    /**
     * <pre>
     * General direction of the fault. If the faults of individual phases have different directions,
     * this attribute shall be set to 'dirGeneral'='both'.
     * </pre>
     *
     * <code>.commonmodule.FaultDirectionKind dirGeneral = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The enum numeric value on the wire for dirGeneral to set.
     * @return This builder for chaining.
     */
    public Builder setDirGeneralValue(int value) {
      dirGeneral_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * General direction of the fault. If the faults of individual phases have different directions,
     * this attribute shall be set to 'dirGeneral'='both'.
     * </pre>
     *
     * <code>.commonmodule.FaultDirectionKind dirGeneral = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The dirGeneral.
     */
    @java.lang.Override
    public openfmb.commonmodule.FaultDirectionKind getDirGeneral() {
      openfmb.commonmodule.FaultDirectionKind result = openfmb.commonmodule.FaultDirectionKind.forNumber(dirGeneral_);
      return result == null ? openfmb.commonmodule.FaultDirectionKind.UNRECOGNIZED : result;
    }
    /**
     * <pre>
     * General direction of the fault. If the faults of individual phases have different directions,
     * this attribute shall be set to 'dirGeneral'='both'.
     * </pre>
     *
     * <code>.commonmodule.FaultDirectionKind dirGeneral = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The dirGeneral to set.
     * @return This builder for chaining.
     */
    public Builder setDirGeneral(openfmb.commonmodule.FaultDirectionKind value) {
      if (value == null) {
        throw new NullPointerException();
      }
      bitField0_ |= 0x00000001;
      dirGeneral_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <pre>
     * General direction of the fault. If the faults of individual phases have different directions,
     * this attribute shall be set to 'dirGeneral'='both'.
     * </pre>
     *
     * <code>.commonmodule.FaultDirectionKind dirGeneral = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearDirGeneral() {
      bitField0_ = (bitField0_ & ~0x00000001);
      dirGeneral_ = 0;
      onChanged();
      return this;
    }

    private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirNeut_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> dirNeutBuilder_;
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     * @return Whether the dirNeut field is set.
     */
    public boolean hasDirNeut() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     * @return The dirNeut.
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirNeut() {
      if (dirNeutBuilder_ == null) {
        return dirNeut_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirNeut_;
      } else {
        return dirNeutBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     */
    public Builder setDirNeut(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirNeutBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dirNeut_ = value;
      } else {
        dirNeutBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     */
    public Builder setDirNeut(
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder builderForValue) {
      if (dirNeutBuilder_ == null) {
        dirNeut_ = builderForValue.build();
      } else {
        dirNeutBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     */
    public Builder mergeDirNeut(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirNeutBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          dirNeut_ != null &&
          dirNeut_ != openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance()) {
          getDirNeutBuilder().mergeFrom(value);
        } else {
          dirNeut_ = value;
        }
      } else {
        dirNeutBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     */
    public Builder clearDirNeut() {
      bitField0_ = (bitField0_ & ~0x00000002);
      dirNeut_ = null;
      if (dirNeutBuilder_ != null) {
        dirNeutBuilder_.dispose();
        dirNeutBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder getDirNeutBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getDirNeutFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirNeutOrBuilder() {
      if (dirNeutBuilder_ != null) {
        return dirNeutBuilder_.getMessageOrBuilder();
      } else {
        return dirNeut_ == null ?
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirNeut_;
      }
    }
    /**
     * <pre>
     * Direction of the fault for earth current.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirNeut = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> 
        getDirNeutFieldBuilder() {
      if (dirNeutBuilder_ == null) {
        dirNeutBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder>(
                getDirNeut(),
                getParentForChildren(),
                isClean());
        dirNeut_ = null;
      }
      return dirNeutBuilder_;
    }

    private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> dirPhsABuilder_;
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     * @return Whether the dirPhsA field is set.
     */
    public boolean hasDirPhsA() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     * @return The dirPhsA.
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirPhsA() {
      if (dirPhsABuilder_ == null) {
        return dirPhsA_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsA_;
      } else {
        return dirPhsABuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     */
    public Builder setDirPhsA(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirPhsABuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dirPhsA_ = value;
      } else {
        dirPhsABuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     */
    public Builder setDirPhsA(
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder builderForValue) {
      if (dirPhsABuilder_ == null) {
        dirPhsA_ = builderForValue.build();
      } else {
        dirPhsABuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     */
    public Builder mergeDirPhsA(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirPhsABuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          dirPhsA_ != null &&
          dirPhsA_ != openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance()) {
          getDirPhsABuilder().mergeFrom(value);
        } else {
          dirPhsA_ = value;
        }
      } else {
        dirPhsABuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     */
    public Builder clearDirPhsA() {
      bitField0_ = (bitField0_ & ~0x00000004);
      dirPhsA_ = null;
      if (dirPhsABuilder_ != null) {
        dirPhsABuilder_.dispose();
        dirPhsABuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder getDirPhsABuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getDirPhsAFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirPhsAOrBuilder() {
      if (dirPhsABuilder_ != null) {
        return dirPhsABuilder_.getMessageOrBuilder();
      } else {
        return dirPhsA_ == null ?
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsA_;
      }
    }
    /**
     * <pre>
     * Direction of the fault for phase A.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsA = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> 
        getDirPhsAFieldBuilder() {
      if (dirPhsABuilder_ == null) {
        dirPhsABuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder>(
                getDirPhsA(),
                getParentForChildren(),
                isClean());
        dirPhsA_ = null;
      }
      return dirPhsABuilder_;
    }

    private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> dirPhsBBuilder_;
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     * @return Whether the dirPhsB field is set.
     */
    public boolean hasDirPhsB() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     * @return The dirPhsB.
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirPhsB() {
      if (dirPhsBBuilder_ == null) {
        return dirPhsB_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsB_;
      } else {
        return dirPhsBBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     */
    public Builder setDirPhsB(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirPhsBBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dirPhsB_ = value;
      } else {
        dirPhsBBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     */
    public Builder setDirPhsB(
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder builderForValue) {
      if (dirPhsBBuilder_ == null) {
        dirPhsB_ = builderForValue.build();
      } else {
        dirPhsBBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     */
    public Builder mergeDirPhsB(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirPhsBBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          dirPhsB_ != null &&
          dirPhsB_ != openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance()) {
          getDirPhsBBuilder().mergeFrom(value);
        } else {
          dirPhsB_ = value;
        }
      } else {
        dirPhsBBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     */
    public Builder clearDirPhsB() {
      bitField0_ = (bitField0_ & ~0x00000008);
      dirPhsB_ = null;
      if (dirPhsBBuilder_ != null) {
        dirPhsBBuilder_.dispose();
        dirPhsBBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder getDirPhsBBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getDirPhsBFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirPhsBOrBuilder() {
      if (dirPhsBBuilder_ != null) {
        return dirPhsBBuilder_.getMessageOrBuilder();
      } else {
        return dirPhsB_ == null ?
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsB_;
      }
    }
    /**
     * <pre>
     * Direction of the fault for phase B.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsB = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> 
        getDirPhsBFieldBuilder() {
      if (dirPhsBBuilder_ == null) {
        dirPhsBBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder>(
                getDirPhsB(),
                getParentForChildren(),
                isClean());
        dirPhsB_ = null;
      }
      return dirPhsBBuilder_;
    }

    private openfmb.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> dirPhsCBuilder_;
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     * @return Whether the dirPhsC field is set.
     */
    public boolean hasDirPhsC() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     * @return The dirPhsC.
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind getDirPhsC() {
      if (dirPhsCBuilder_ == null) {
        return dirPhsC_ == null ? openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsC_;
      } else {
        return dirPhsCBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     */
    public Builder setDirPhsC(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirPhsCBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dirPhsC_ = value;
      } else {
        dirPhsCBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     */
    public Builder setDirPhsC(
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder builderForValue) {
      if (dirPhsCBuilder_ == null) {
        dirPhsC_ = builderForValue.build();
      } else {
        dirPhsCBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     */
    public Builder mergeDirPhsC(openfmb.commonmodule.Optional_PhaseFaultDirectionKind value) {
      if (dirPhsCBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          dirPhsC_ != null &&
          dirPhsC_ != openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance()) {
          getDirPhsCBuilder().mergeFrom(value);
        } else {
          dirPhsC_ = value;
        }
      } else {
        dirPhsCBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     */
    public Builder clearDirPhsC() {
      bitField0_ = (bitField0_ & ~0x00000010);
      dirPhsC_ = null;
      if (dirPhsCBuilder_ != null) {
        dirPhsCBuilder_.dispose();
        dirPhsCBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder getDirPhsCBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getDirPhsCFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     */
    public openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder getDirPhsCOrBuilder() {
      if (dirPhsCBuilder_ != null) {
        return dirPhsCBuilder_.getMessageOrBuilder();
      } else {
        return dirPhsC_ == null ?
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind.getDefaultInstance() : dirPhsC_;
      }
    }
    /**
     * <pre>
     * Direction of the fault for phase C.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseFaultDirectionKind dirPhsC = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder> 
        getDirPhsCFieldBuilder() {
      if (dirPhsCBuilder_ == null) {
        dirPhsCBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_PhaseFaultDirectionKind, openfmb.commonmodule.Optional_PhaseFaultDirectionKind.Builder, openfmb.commonmodule.Optional_PhaseFaultDirectionKindOrBuilder>(
                getDirPhsC(),
                getParentForChildren(),
                isClean());
        dirPhsC_ = null;
      }
      return dirPhsCBuilder_;
    }

    private boolean general_ ;
    /**
     * <pre>
     * General indication of a protection activation (e.g. by the fault). Depending on the function,
     * 'general' may or may not be resulting from the phase attributes (phsA', 'phsB', 'phsC', 'neut').
     * </pre>
     *
     * <code>bool general = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The general.
     */
    @java.lang.Override
    public boolean getGeneral() {
      return general_;
    }
    /**
     * <pre>
     * General indication of a protection activation (e.g. by the fault). Depending on the function,
     * 'general' may or may not be resulting from the phase attributes (phsA', 'phsB', 'phsC', 'neut').
     * </pre>
     *
     * <code>bool general = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The general to set.
     * @return This builder for chaining.
     */
    public Builder setGeneral(boolean value) {

      general_ = value;
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * General indication of a protection activation (e.g. by the fault). Depending on the function,
     * 'general' may or may not be resulting from the phase attributes (phsA', 'phsB', 'phsC', 'neut').
     * </pre>
     *
     * <code>bool general = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearGeneral() {
      bitField0_ = (bitField0_ & ~0x00000020);
      general_ = false;
      onChanged();
      return this;
    }

    private com.google.protobuf.BoolValue neut_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> neutBuilder_;
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     * @return Whether the neut field is set.
     */
    public boolean hasNeut() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     * @return The neut.
     */
    public com.google.protobuf.BoolValue getNeut() {
      if (neutBuilder_ == null) {
        return neut_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : neut_;
      } else {
        return neutBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     */
    public Builder setNeut(com.google.protobuf.BoolValue value) {
      if (neutBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        neut_ = value;
      } else {
        neutBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     */
    public Builder setNeut(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (neutBuilder_ == null) {
        neut_ = builderForValue.build();
      } else {
        neutBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     */
    public Builder mergeNeut(com.google.protobuf.BoolValue value) {
      if (neutBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0) &&
          neut_ != null &&
          neut_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getNeutBuilder().mergeFrom(value);
        } else {
          neut_ = value;
        }
      } else {
        neutBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     */
    public Builder clearNeut() {
      bitField0_ = (bitField0_ & ~0x00000040);
      neut_ = null;
      if (neutBuilder_ != null) {
        neutBuilder_.dispose();
        neutBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     */
    public com.google.protobuf.BoolValue.Builder getNeutBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getNeutFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getNeutOrBuilder() {
      if (neutBuilder_ != null) {
        return neutBuilder_.getMessageOrBuilder();
      } else {
        return neut_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : neut_;
      }
    }
    /**
     * <pre>
     * See 'ACT.neut'.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue neut = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getNeutFieldBuilder() {
      if (neutBuilder_ == null) {
        neutBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getNeut(),
                getParentForChildren(),
                isClean());
        neut_ = null;
      }
      return neutBuilder_;
    }

    private com.google.protobuf.BoolValue phsA_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> phsABuilder_;
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     * @return Whether the phsA field is set.
     */
    public boolean hasPhsA() {
      return ((bitField0_ & 0x00000080) != 0);
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     * @return The phsA.
     */
    public com.google.protobuf.BoolValue getPhsA() {
      if (phsABuilder_ == null) {
        return phsA_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsA_;
      } else {
        return phsABuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     */
    public Builder setPhsA(com.google.protobuf.BoolValue value) {
      if (phsABuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phsA_ = value;
      } else {
        phsABuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     */
    public Builder setPhsA(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (phsABuilder_ == null) {
        phsA_ = builderForValue.build();
      } else {
        phsABuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     */
    public Builder mergePhsA(com.google.protobuf.BoolValue value) {
      if (phsABuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0) &&
          phsA_ != null &&
          phsA_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getPhsABuilder().mergeFrom(value);
        } else {
          phsA_ = value;
        }
      } else {
        phsABuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     */
    public Builder clearPhsA() {
      bitField0_ = (bitField0_ & ~0x00000080);
      phsA_ = null;
      if (phsABuilder_ != null) {
        phsABuilder_.dispose();
        phsABuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     */
    public com.google.protobuf.BoolValue.Builder getPhsABuilder() {
      bitField0_ |= 0x00000080;
      onChanged();
      return getPhsAFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getPhsAOrBuilder() {
      if (phsABuilder_ != null) {
        return phsABuilder_.getMessageOrBuilder();
      } else {
        return phsA_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : phsA_;
      }
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase A.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsA = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getPhsAFieldBuilder() {
      if (phsABuilder_ == null) {
        phsABuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getPhsA(),
                getParentForChildren(),
                isClean());
        phsA_ = null;
      }
      return phsABuilder_;
    }

    private com.google.protobuf.BoolValue phsB_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> phsBBuilder_;
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     * @return Whether the phsB field is set.
     */
    public boolean hasPhsB() {
      return ((bitField0_ & 0x00000100) != 0);
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     * @return The phsB.
     */
    public com.google.protobuf.BoolValue getPhsB() {
      if (phsBBuilder_ == null) {
        return phsB_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsB_;
      } else {
        return phsBBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     */
    public Builder setPhsB(com.google.protobuf.BoolValue value) {
      if (phsBBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phsB_ = value;
      } else {
        phsBBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     */
    public Builder setPhsB(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (phsBBuilder_ == null) {
        phsB_ = builderForValue.build();
      } else {
        phsBBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     */
    public Builder mergePhsB(com.google.protobuf.BoolValue value) {
      if (phsBBuilder_ == null) {
        if (((bitField0_ & 0x00000100) != 0) &&
          phsB_ != null &&
          phsB_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getPhsBBuilder().mergeFrom(value);
        } else {
          phsB_ = value;
        }
      } else {
        phsBBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     */
    public Builder clearPhsB() {
      bitField0_ = (bitField0_ & ~0x00000100);
      phsB_ = null;
      if (phsBBuilder_ != null) {
        phsBBuilder_.dispose();
        phsBBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     */
    public com.google.protobuf.BoolValue.Builder getPhsBBuilder() {
      bitField0_ |= 0x00000100;
      onChanged();
      return getPhsBFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getPhsBOrBuilder() {
      if (phsBBuilder_ != null) {
        return phsBBuilder_.getMessageOrBuilder();
      } else {
        return phsB_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : phsB_;
      }
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase B.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsB = 9;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getPhsBFieldBuilder() {
      if (phsBBuilder_ == null) {
        phsBBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getPhsB(),
                getParentForChildren(),
                isClean());
        phsB_ = null;
      }
      return phsBBuilder_;
    }

    private com.google.protobuf.BoolValue phsC_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> phsCBuilder_;
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     * @return Whether the phsC field is set.
     */
    public boolean hasPhsC() {
      return ((bitField0_ & 0x00000200) != 0);
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     * @return The phsC.
     */
    public com.google.protobuf.BoolValue getPhsC() {
      if (phsCBuilder_ == null) {
        return phsC_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : phsC_;
      } else {
        return phsCBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     */
    public Builder setPhsC(com.google.protobuf.BoolValue value) {
      if (phsCBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phsC_ = value;
      } else {
        phsCBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     */
    public Builder setPhsC(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (phsCBuilder_ == null) {
        phsC_ = builderForValue.build();
      } else {
        phsCBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     */
    public Builder mergePhsC(com.google.protobuf.BoolValue value) {
      if (phsCBuilder_ == null) {
        if (((bitField0_ & 0x00000200) != 0) &&
          phsC_ != null &&
          phsC_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getPhsCBuilder().mergeFrom(value);
        } else {
          phsC_ = value;
        }
      } else {
        phsCBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     */
    public Builder clearPhsC() {
      bitField0_ = (bitField0_ & ~0x00000200);
      phsC_ = null;
      if (phsCBuilder_ != null) {
        phsCBuilder_.dispose();
        phsCBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     */
    public com.google.protobuf.BoolValue.Builder getPhsCBuilder() {
      bitField0_ |= 0x00000200;
      onChanged();
      return getPhsCFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getPhsCOrBuilder() {
      if (phsCBuilder_ != null) {
        return phsCBuilder_.getMessageOrBuilder();
      } else {
        return phsC_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : phsC_;
      }
    }
    /**
     * <pre>
     * Value true indicates a trip or a start event of phase C.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue phsC = 10;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getPhsCFieldBuilder() {
      if (phsCBuilder_ == null) {
        phsCBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getPhsC(),
                getParentForChildren(),
                isClean());
        phsC_ = null;
      }
      return phsCBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.ACD)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.ACD)
  private static final openfmb.commonmodule.ACD DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.ACD();
  }

  public static openfmb.commonmodule.ACD getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ACD>
      PARSER = new com.google.protobuf.AbstractParser<ACD>() {
    @java.lang.Override
    public ACD parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ACD> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ACD> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.ACD getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

